
; ROM generator for MSX ROM-loader for SVI-328 ver:1.3 Made By: NYYRIKKI 2016
;-----------------------------------------------------------------------------
;
; This program will generate SVI-ROM that can be burned to EPROM chip.
; This version supports only packed MSX ROMs.

 INCLUDE "TOSVIROM.INC"

/* ; These come from TOSVIROM.INC:
PATCH_MODE	EQU 2		;See TOSVIROM.TXT
GAME_SIZE	EQU 32;KB       ;Original size before packing
DEFINE FILE1    "GAME.001"
DEFINE FILE2    "GAME.002"
  OUTPUT        "GAME.ROM"
*/

;-----------------------------------------------------------------------------

; Loader code starts here:

	ORG 0
	DI	;Two first commands needs always to be DI and LD SP,xxxx
	LD SP,#FFFF

	LD A,#DE
	LD (#8C),A	; Switch RAM visible.

	LD HL,MOVEUP_START
	LD DE,BAS_CALL
	LD BC,MOVEUP_END-MOVEUP_START
	LDIR

	LD DE,(EXEROM_START)	;Read BLOAD-header
	LD HL,(EXEROM_START+2)
	LD IX,(EXEROM_START+4)
	XOR A
	SBC HL,DE
	PUSH HL
	POP BC
	LD HL,EXEROM_START+6
	LDIR
	CALL BAS_CALL

	IF (PATCH_MODE<2)
	LD A,2
	LD HL,MODE_SEL
	LD IX,#D320
	CALL BAS_CALL
	ENDIF

	LD HL,DATA1_START
	LD DE,#8800
	LD BC,DATA1_END-DATA1_START
	LDIR
	IF (GAME_SIZE==8)
	LD IX,#D004
	ENDIF
	IF (GAME_SIZE==16)
	LD IX,#D00C
	ENDIF
	IF (GAME_SIZE==32)
	LD IX,#D014
	ENDIF
	CALL BAS_CALL

	IF (GAME_SIZE==32)
	LD HL,DATA2_START
	LD DE,#8800
	LD BC,DATA2_END-DATA2_START
	LDIR
	LD IX,#D01C
	JP BAS_CALL

DATA2_START:
	INCBIN FILE2
DATA2_END:
	ENDIF
DATA1_START:
	INCBIN FILE1
DATA1_END
EXEROM_START:
	INCBIN "EXEROM"
EXEROM_END:


MOVEUP_START
	PHASE #8000
BAS_CALL:
	LD	A,15
	OUT	(#88), A ; select PSG register 15 (Port B)
	LD A,#DF
	OUT	(#8C),A	; switch BASIC visible
	CALL .JPIX
	LD	A,#DE
	OUT	(#8C),A	; switch back to ROM
	RET
.JPIX	JP (IX)
MODE_SEL DW 0
 	DB PATCH_MODE
	DEPHASE
MOVEUP_END
	IF ($<#4000)
	DS #4000-$	;Fill up to 16K
	ELSE
      	DS #8000-$	;Fill up to 32K
      	ENDIF